Bug 333 (bogus-build)

Summary: Obsolete bug, report build bugs in "build" component (was: Do not report build errors in bugzilla!)
Product: glibc Reporter: Roland McGrath <roland>
Component: buildAssignee: Roland McGrath <roland>
Status: RESOLVED INVALID    
Severity: normal CC: abhishek.belgundi, aleppos, allan, arthur.loiret, booleandomain, carlos, dgibelli, felix-glibc, glibc-bugs, gregh, hjl.tools, jason.vas.dias, karsten, matteosistisette, moleque_da_rua, netjoker4.5, pierre42d, robxu9, sergstesh, suma.sharma, yangshaoxing
Priority: P1 Flags: fweimer: security-
Version: unspecified   
Target Milestone: ---   
Host: Target:
Build: Last reconfirmed:

Description Roland McGrath 2004-08-16 20:38:30 UTC
This is a placeholder bug; other bugs are marked as duplicates of this bug when
they are improper reports about problems compiling glibc.  If you try to compile
glibc yourself and have build errors or test case failures you do not
understand, then do not report them in bugzilla.  The developers do builds and
make check runs on a regular basis, and if there is any real problem they will
notice it and fix it quickly.  It is much more likely that there is something
amiss in your build environment or in how you have gone about trying to
configure and build glibc.  Building glibc properly is a complex operation with
many particular dependencies.  If you insist on doing it yourself, you will have
to investigate your issues and resolve them yourself.  If you really know what
you are doing and find a real problem, then you will be able to file a specific
bug report with enough detailed information that we will be able to look into
the issue.  If your bug got marked as a duplicate of this bug, then it was not
sufficient and you need to look into your problem yourself.

We appreciate efforts to test glibc, but doing so usefully is somewhat
difficult.  Just trying it without understanding glibc development in detail,
and reporting some test failures, is not a helpful thing to do at all.  If you
are experienced in glibc development, then the best way to help with testing is
to test the binary packages made by your operating system distributor and report
issues to that distributor.  Never report issues with binary packages to this
bugzilla database.
Comment 1 Roland McGrath 2004-08-16 20:40:06 UTC
This placeholder bug is closed and given the alias "bogus-build".
Inappropriate user reports will be marked as dups of this bug.
Comment 2 Roland McGrath 2004-08-16 20:41:09 UTC
*** Bug 331 has been marked as a duplicate of this bug. ***
Comment 3 Ulrich Drepper 2004-08-18 19:42:24 UTC
*** Bug 328 has been marked as a duplicate of this bug. ***
Comment 4 Ulrich Drepper 2004-09-12 19:28:46 UTC
*** Bug 344 has been marked as a duplicate of this bug. ***
Comment 5 Ulrich Drepper 2004-09-12 19:29:18 UTC
*** Bug 326 has been marked as a duplicate of this bug. ***
Comment 6 Roland McGrath 2004-09-13 19:02:06 UTC
*** Bug 382 has been marked as a duplicate of this bug. ***
Comment 7 Roland McGrath 2004-09-15 00:37:39 UTC
*** Bug 385 has been marked as a duplicate of this bug. ***
Comment 8 David Daney 2004-09-15 00:48:31 UTC
What about build errors that I do understand and have patches for and that are
real errors in glibc?

I guess that they go here also.
Comment 9 Roland McGrath 2004-09-15 01:52:16 UTC
Reports about build issues of any kind do not belong in bugzilla.
If you have bona fide issues and fixes for them, we welcome your direct
participation in glibc development by using the public development mailing lists.
Any bona fide build issue is a platform-specific problem on a platform whose
maintainer has not updated the code recently, or whose build environment does
not have the same problems you encountered.  The details need to be taken up
with the architecture's maintainer, who will submit appropriate fixes for inclusion.
Comment 10 Roland McGrath 2004-09-23 02:22:15 UTC
*** Bug 398 has been marked as a duplicate of this bug. ***
Comment 11 duncan_roe 2004-09-23 14:36:39 UTC
Subject: Re:  Do not report build errors in bugzilla!

Hi Mark,

I'm a Slackware afficinado myself, having used it for 11 years: reckon it's
great!!

Take a look at bug 326

Ok it just happens that Richard Stallman is giving a presentation in my home
town (Melbourne Australia) on 7/10 and I plan to ask him to comment on the
attitude we are seeing from the glibc engineers.

I myself have had a few problems but then I have a dual Opteron and have yet to
build a gcc that will pass 'make check' - if you have anything that you think
should work I would be very happy to test it for you (or anyone else at
Slackware).

I submitted bugs 312, 313, 328, 329, 330, 331 & 332.
Rather a lot, I supose (cf Monty Python, "rat tart" :)

Cheers ... Duncan.

On Thu, Sep 23, 2004 at 04:48:12AM -0000, markkp at slackware dot com wrote:
>
>
> --
>            What    |Removed                     |Added
> ----------------------------------------------------------------------------
>                  CC|markkp at slackware dot com |
>
>
> http://sources.redhat.com/bugzilla/show_bug.cgi?id=333
>
> ------- You are receiving this mail because: -------
> You are on the CC list for the bug, or are watching someone who is.
Comment 12 Ulrich Drepper 2004-09-26 12:46:45 UTC
*** Bug 398 has been marked as a duplicate of this bug. ***
Comment 13 Jakub Jelinek 2004-09-26 16:16:10 UTC
*** Bug 398 has been marked as a duplicate of this bug. ***
Comment 14 GOTO Masanori 2004-09-27 12:37:54 UTC
*** Bug 90 has been marked as a duplicate of this bug. ***
Comment 15 GOTO Masanori 2004-09-28 01:52:59 UTC
*** Bug 235 has been marked as a duplicate of this bug. ***
Comment 16 Andreas Jaeger 2004-12-13 14:34:45 UTC
*** Bug 607 has been marked as a duplicate of this bug. ***
Comment 17 Andreas Jaeger 2004-12-18 15:16:59 UTC
*** Bug 593 has been marked as a duplicate of this bug. ***
Comment 18 Andreas Jaeger 2005-01-18 08:27:24 UTC
*** Bug 675 has been marked as a duplicate of this bug. ***
Comment 19 GOTO Masanori 2005-02-14 12:11:13 UTC
*** Bug 701 has been marked as a duplicate of this bug. ***
Comment 20 Roland McGrath 2005-02-25 00:54:18 UTC
*** Bug 764 has been marked as a duplicate of this bug. ***
Comment 21 Roland McGrath 2005-03-03 00:34:46 UTC
*** Bug 721 has been marked as a duplicate of this bug. ***
Comment 22 Jakub Jelinek 2005-03-24 10:45:14 UTC
*** Bug 802 has been marked as a duplicate of this bug. ***
Comment 23 Roland McGrath 2005-04-07 20:19:30 UTC
*** Bug 833 has been marked as a duplicate of this bug. ***
Comment 24 Ulrich Drepper 2005-04-14 21:26:37 UTC
*** Bug 849 has been marked as a duplicate of this bug. ***
Comment 25 Ulrich Drepper 2005-04-14 21:27:59 UTC
*** Bug 839 has been marked as a duplicate of this bug. ***
Comment 26 Ulrich Drepper 2005-04-17 16:38:26 UTC
*** Bug 856 has been marked as a duplicate of this bug. ***
Comment 27 Roland McGrath 2005-07-19 03:44:29 UTC
*** Bug 1045 has been marked as a duplicate of this bug. ***
Comment 28 Roland McGrath 2005-07-19 03:45:25 UTC
*** Bug 631 has been marked as a duplicate of this bug. ***
Comment 29 Ulrich Drepper 2005-09-27 15:27:39 UTC
*** Bug 1071 has been marked as a duplicate of this bug. ***
Comment 30 Ulrich Drepper 2005-09-28 17:34:08 UTC
*** Bug 1316 has been marked as a duplicate of this bug. ***
Comment 31 Ulrich Drepper 2005-10-15 19:45:30 UTC
*** Bug 1394 has been marked as a duplicate of this bug. ***
Comment 32 Ulrich Drepper 2005-10-24 14:07:42 UTC
*** Bug 1534 has been marked as a duplicate of this bug. ***
Comment 33 Ulrich Drepper 2005-11-06 20:59:20 UTC
*** Bug 1815 has been marked as a duplicate of this bug. ***
Comment 34 Roland McGrath 2006-01-08 03:27:11 UTC
*** Bug 2124 has been marked as a duplicate of this bug. ***
Comment 35 Ulrich Drepper 2006-01-19 17:09:34 UTC
*** Bug 2179 has been marked as a duplicate of this bug. ***
Comment 36 Roland McGrath 2006-01-25 18:53:21 UTC
*** Bug 2206 has been marked as a duplicate of this bug. ***
Comment 37 Perttu Halonen 2006-03-02 19:53:15 UTC
*** Bug 2410 has been marked as a duplicate of this bug. ***
Comment 38 Jon Grosshart 2006-03-05 17:20:14 UTC
Hey guys... If your finding yourself at this page after doing a 'make check' on
glibc, I thought I'd share some expierences with you instead of saying IT WORKS
FOR ME. Yes, the maintainers have more pressing bussiness at hand besides being
our personal tech support, but still... A good percentage of people seeking help
are coming from the LFS/DIY circle and we can't use the distributors binary of
glibc... WE ARE THE DISTRIBUTORS! :-)

Over the past couple years, I've come to realize one important factor about
building glibc. It is HIGHLY DEPENDENT upon your running host kernel (among
other things). I often expierence nptl test failures when running a 2.6 kernel
built with gcc-3.3.x (slackintosh/slackware). Upgrade your gcc to 3.4.5 and
recompile a new kernel on the host and the nptl test errors will more than
likely dissapear. How Pat avoids these problems, I'm still not sure of.

If you find yourself getting certain posix errors, I've found that some of these
are due to not having a correctly populated /dev directory. Since alot of us are
chrooting into an environment that has no working udev yet, run the MAKEDEV
script and alot of these errors will also dissappear.

I also get some "Time out" errors on occassion after a long uptime on an
old/slow processor / limited memory machine. It COULD be helpfull to clear out
your ps list or simpily reboot and try again. Glibc can be finicky when it comes
to the host environment in general, is my main point. Don't underestimate the
impact of your host when you think you are isolated in chroot.

With a little perseverance, googling skill and competence on your part, you can
whittle down your glibc check errors to just the standard "posix/annexc.out
Error 1 (ignored)" error.

Good luck.
Comment 39 Ulrich Drepper 2006-04-02 17:43:00 UTC
*** Bug 2487 has been marked as a duplicate of this bug. ***
Comment 40 Ulrich Drepper 2006-04-09 04:44:33 UTC
*** Bug 2529 has been marked as a duplicate of this bug. ***
Comment 41 Dwayne Grant McConnell 2006-05-17 18:41:59 UTC
*** Bug 2672 has been marked as a duplicate of this bug. ***
Comment 42 Ulrich Drepper 2006-05-24 14:52:19 UTC
*** Bug 2694 has been marked as a duplicate of this bug. ***
Comment 43 Jakub Jelinek 2006-06-19 11:39:08 UTC
*** Bug 849 has been marked as a duplicate of this bug. ***
Comment 44 Alan Hourihane 2006-06-19 11:42:42 UTC
I'd appreciate not adding me as a CC back on this Jakub.
Comment 45 Andreas Jaeger 2006-07-10 09:34:17 UTC
*** Bug 2887 has been marked as a duplicate of this bug. ***
Comment 46 Andreas Jaeger 2006-07-10 09:35:29 UTC
*** Bug 2894 has been marked as a duplicate of this bug. ***
Comment 47 Ulrich Drepper 2006-07-30 20:47:00 UTC
*** Bug 2982 has been marked as a duplicate of this bug. ***
Comment 48 Ulrich Drepper 2006-08-03 08:18:52 UTC
*** Bug 2929 has been marked as a duplicate of this bug. ***
Comment 49 Ulrich Drepper 2006-08-03 16:08:21 UTC
*** Bug 2996 has been marked as a duplicate of this bug. ***
Comment 50 Ulrich Drepper 2006-08-03 18:43:07 UTC
*** Bug 2175 has been marked as a duplicate of this bug. ***
Comment 51 Andrew Pinski 2006-08-04 03:00:04 UTC
I think the overall of this bug is not a good one. Witness PR 2672 which was just found to be a GCC bug 
today but it was reported to glibc back in May.  Can people don't close the bugs without at least asking 
what version of GCC/binutils they are using?  GCC gets build failure bugs all the time and we don't close 
them as a dup of one bug saying don't report build failures.  In fact the opposite happens, usually it is 
obviously what is wrong and other times it is not so.  If glibc does not care about the quality of the 
building of glibc, well it looks that way with this mass closing of bug reports without actually looking into 
them.
Comment 52 Ulrich Drepper 2006-08-12 20:28:37 UTC
*** Bug 2873 has been marked as a duplicate of this bug. ***
Comment 53 Ulrich Drepper 2006-10-16 10:44:56 UTC
*** Bug 3368 has been marked as a duplicate of this bug. ***
Comment 54 Ulrich Drepper 2006-10-20 14:42:10 UTC
*** Bug 3403 has been marked as a duplicate of this bug. ***
Comment 55 Ulrich Drepper 2006-11-11 02:40:20 UTC
*** Bug 3505 has been marked as a duplicate of this bug. ***
Comment 56 Nadav 2006-11-11 09:03:09 UTC
How do I remove myself from getting update for this "bug" to my mail?????
Comment 57 Ulrich Drepper 2006-12-29 22:18:38 UTC
*** Bug 3817 has been marked as a duplicate of this bug. ***
Comment 58 Ulrich Drepper 2007-01-22 06:22:53 UTC
*** Bug 3900 has been marked as a duplicate of this bug. ***
Comment 59 Ulrich Drepper 2007-02-07 09:13:09 UTC
*** Bug 3989 has been marked as a duplicate of this bug. ***
Comment 60 Dan 2007-02-07 10:17:01 UTC
Kindly then where does one discuss build errors then??  Can a link to such be
provided in this thread?

I am also wondering if there is some bug in ldd 2.4 when it comes to relinking
glibc 2.4 again....as I have already successfully compiled and installed it
migrating from an earlier version of glibc.  Though contemplating it one would
think that the developers would have been in a position to test this
extensively.  I don't feel like upgrading to the latest CVS at this time.

Comment 61 Ulrich Drepper 2007-02-10 17:36:32 UTC
*** Bug 4021 has been marked as a duplicate of this bug. ***
Comment 62 Ulrich Drepper 2007-02-11 19:25:50 UTC
*** Bug 4025 has been marked as a duplicate of this bug. ***
Comment 63 Ulrich Drepper 2007-03-06 19:29:59 UTC
*** Bug 4139 has been marked as a duplicate of this bug. ***
Comment 64 Ulrich Drepper 2007-03-07 00:13:55 UTC
*** Bug 2894 has been marked as a duplicate of this bug. ***
Comment 65 Ulrich Drepper 2007-03-13 13:49:17 UTC
*** Bug 4182 has been marked as a duplicate of this bug. ***
Comment 66 Ulrich Drepper 2007-05-04 14:00:00 UTC
*** Bug 4461 has been marked as a duplicate of this bug. ***
Comment 67 Ulrich Drepper 2007-07-07 16:36:37 UTC
*** Bug 4750 has been marked as a duplicate of this bug. ***
Comment 68 Ulrich Drepper 2007-11-12 16:21:10 UTC
*** Bug 5313 has been marked as a duplicate of this bug. ***
Comment 69 Ulrich Drepper 2007-11-28 22:12:37 UTC
*** Bug 5425 has been marked as a duplicate of this bug. ***
Comment 70 Ulrich Drepper 2007-12-10 02:25:30 UTC
*** Bug 5462 has been marked as a duplicate of this bug. ***
Comment 71 Ulrich Drepper 2007-12-20 16:13:58 UTC
*** Bug 5515 has been marked as a duplicate of this bug. ***
Comment 72 Ulrich Drepper 2008-02-10 11:22:38 UTC
*** Bug 5752 has been marked as a duplicate of this bug. ***
Comment 73 Dick Rock 2008-02-10 18:49:43 UTC
Subject: Re:  Do not report build errors in bugzilla!

The glibc library did not build nor did it recognize
the machine.
Now, How do I correct this?

--- drepper at redhat dot com
<sourceware-bugzilla@sourceware.org> wrote:

> 
> ------- Additional Comments From drepper at redhat
> dot com  2008-02-10 11:22 -------
> *** Bug 5752 has been marked as a duplicate of this
> bug. ***
> 
> -- 
>            What    |Removed                    
> |Added
>
----------------------------------------------------------------------------
>                  CC|                           
> |moleque_da_rua at yahoo dot
>                    |                            |com
> 
> 
> http://sourceware.org/bugzilla/show_bug.cgi?id=333
> 
> ------- You are receiving this mail because: -------
> You are on the CC list for the bug, or are watching
> someone who is.
> 



      ____________________________________________________________________________________
Looking for last minute shopping deals?  
Find them fast with Yahoo! Search.  http://tools.search.yahoo.com/newsearch/category.php?category=shopping
Comment 74 Dick Rock 2008-02-10 18:51:23 UTC
Subject: Fwd:  Do not report build errors in bugzilla!

Note: forwarded message attached.



      ____________________________________________________________________________________
Never miss a thing.  Make Yahoo your home page. 
http://www.yahoo.com/r/hs
------- Additional Comments From moleque_da_rua at yahoo dot com  2008-02-10 18:49 -------
Subject: Re:  Do not report build errors in bugzilla!

The glibc library did not build nor did it recognize
the machine.
Now, How do I correct this?

--- drepper at redhat dot com
<sourceware-bugzilla@sourceware.org> wrote:

> 
> ------- Additional Comments From drepper at redhat
> dot com  2008-02-10 11:22 -------
> *** Bug 5752 has been marked as a duplicate of this
> bug. ***
> 
> -- 
>            What    |Removed                    
> |Added
>
----------------------------------------------------------------------------
>                  CC|                           
> |moleque_da_rua at yahoo dot
>                    |                            |com
> 
> 
> http://sourceware.org/bugzilla/show_bug.cgi?id=333
> 
> ------- You are receiving this mail because: -------
> You are on the CC list for the bug, or are watching
> someone who is.
> 



      ____________________________________________________________________________________
Looking for last minute shopping deals?  
Find them fast with Yahoo! Search.  http://tools.search.yahoo.com/newsearch/category.php?category=shopping


-- 


http://sourceware.org/bugzilla/show_bug.cgi?id=333

------- You are receiving this mail because: -------
You are on the CC list for the bug, or are watching someone who is.
Comment 75 Ulrich Drepper 2008-04-14 14:04:20 UTC
*** Bug 6398 has been marked as a duplicate of this bug. ***
Comment 76 Ulrich Drepper 2008-05-25 16:55:28 UTC
*** Bug 6560 has been marked as a duplicate of this bug. ***
Comment 77 Ulrich Drepper 2009-04-11 08:55:34 UTC
*** Bug 10060 has been marked as a duplicate of this bug. ***
Comment 78 Ulrich Drepper 2009-04-11 17:36:40 UTC
*** Bug 10062 has been marked as a duplicate of this bug. ***
Comment 79 Ulrich Drepper 2009-07-17 06:00:41 UTC
*** Bug 10375 has been marked as a duplicate of this bug. ***
Comment 80 Ulrich Drepper 2009-07-30 05:29:41 UTC
*** Bug 10463 has been marked as a duplicate of this bug. ***
Comment 81 Andreas Jaeger 2009-07-30 11:03:49 UTC
*** Bug 10464 has been marked as a duplicate of this bug. ***
Comment 82 Ulrich Drepper 2009-07-31 18:15:21 UTC
*** Bug 10470 has been marked as a duplicate of this bug. ***
Comment 83 Ulrich Drepper 2009-10-30 06:23:41 UTC
*** Bug 10369 has been marked as a duplicate of this bug. ***
Comment 84 Ulrich Drepper 2009-11-02 17:41:25 UTC
*** Bug 2894 has been marked as a duplicate of this bug. ***
Comment 85 Petr Baudis 2009-11-11 21:58:34 UTC
*** Bug 10941 has been marked as a duplicate of this bug. ***
Comment 86 Andreas Schwab 2009-11-12 15:47:24 UTC
*** Bug 10941 has been marked as a duplicate of this bug. ***
Comment 87 Ulrich Drepper 2009-11-13 17:11:32 UTC
*** Bug 10954 has been marked as a duplicate of this bug. ***
Comment 88 TGP1994 2009-11-27 16:13:56 UTC
Maintainers and developers, I bet you are wondering why you end up having to
close so many open bogus bugs that are related to build errors. That's because
there does not appear to be a single guide instructing us how to fix these
problems. People, this issue/confusion isn't going to fix its self, that's for
sure. Someone needs to step up here and help us out.
Comment 89 Sergei Steshenko 2009-11-27 16:51:02 UTC
(In reply to comment #88)
> Maintainers and developers, I bet you are wondering why you end up having to
> close so many open bogus bugs that are related to build errors. That's because
> there does not appear to be a single guide instructing us how to fix these
> problems. People, this issue/confusion isn't going to fix its self, that's for
> sure. Someone needs to step up here and help us out.

No, it's just the main developer's attitude - it's impossible for him to
acknowledge that build system has bugs.

By the way, typical closure of WORKSFORME is often a plain lie - as I already wrote.

This is because to make such claim the developer needs to run build in end
user's environment - in my case I have a "one button" tool which builds
literally hundreds of targets. But the developer hasn't even asked for the tool.

Another issue - I managed to build 'glibc-2.9', but using _exactly_ the same
settings I can't build 'glibc-2.10.1', so it's a clear regression. I need to
find time to file this bug.

And I looked into the build system, and I already know there is at least a
couple of things that are screwed up, and I even know places in the build code
where they are screwed up - again, I need to find time to file these bugs.


FWIW, I will absolutely _never_ recommend sourceware/RedHat as service provider
to anybody - my dealing with this infamous bug #333 will be a clearly documented
example why.
Comment 90 Ulrich Drepper 2010-01-18 20:21:26 UTC
*** Bug 11180 has been marked as a duplicate of this bug. ***
Comment 91 Ulrich Drepper 2010-02-04 04:58:26 UTC
*** Bug 11245 has been marked as a duplicate of this bug. ***
Comment 92 Greg 2010-02-05 02:24:48 UTC
Regarding the existence of place holder bugs.

Fuck you.

Are all the engineers female, I don't understand. Stop bitching. It works with
previous kernels, but it doesn't with the newest.

Stop bitching...

Yours truly.
Comment 93 Sergei Steshenko 2010-02-05 02:41:22 UTC
(In reply to comment #92)
> Regarding the existence of place holder bugs.
> 
> Fuck you.
> 
> Are all the engineers female, I don't understand. Stop bitching. It works with
> previous kernels, but it doesn't with the newest.
> 
> Stop bitching...
> 
> Yours truly.

Re(read) my comment somewhat above. Spread the word about the way bug reports
are dealt with.
Comment 94 Petr Baudis 2010-02-05 10:01:54 UTC
I don't want to start a flamewar, especially in this bug. Greg, you are the one
complaining, not us. Noone is paid to support people trying to compile their own
glibc (usually with massive ./configure commandlines often bearing no
resemblance to those used in distribution packages), unfortunately, and the
project lacks any _volunteers_ to do that work.

This is why we have to deal with build problem bugs in this way, just letting
them pollute the bugzilla database in open state indefinitely is even worse.
There is no obligation for noone here to provide technical support; sometimes we
do, sometimes we can't. Sergei, if you want to volunteer to help people with
their build problems, I think you would be welcome to - just revisit bugs closed
as dupes of this. Are you willing to spend the time? The same applies to the
lack of comprehensive and up-to-date build instructions. As tgp1994 said,
someone indeed needs to step in and help out here for the situation to improve,
but it's easy to follow up "but it can't be me because X".

If you want to continue this discussion *and* have concrete technical
suggestions that do not involve the current already-overworked libc hackers
spending more time supporting users trying to compile their own libc, please
follow up on libc-help.
Comment 95 Greg 2010-02-05 10:50:34 UTC
Pasky,

Who's not overworked? Apparently I'm not the only one according to Sergei.

I would NOT have filed a bug report for the following circumstances:
1) Issues with newer dependencies (in my case, a newer kernel) had been stated
as a reason why not to file in the url below.
2) If http://sources.redhat.com/bugzilla/bugwritinghelp.html stated "If you try
to compile glibc yourself and have build errors or test case failures you do not
understand, then do not report them in bugzilla."

If I even had even seen Sergeis' comment before filing a bug report while doing
a search, rest assured that, even if the bug was appropriate enough to be filed,
that I would NOT have filed it!

Thanks, but no thanks.
Comment 96 Sergei Steshenko 2010-02-05 12:41:53 UTC
I very carefully consider behavior of those whom I might help. Developers of
'glibc' are absolutely no freaking way such people - because first and foremost
they are not ready to admit they have bugs.

Regarding "Building glibc properly is a complex operation with many particular
dependencies" - let me translate it for you: build documentation is of
unbelievably low quality. It was enough for me to discover that having _exactly_
the same settings (i.e. both dependencies and command line options) I can
successfully build one 'glibc' version and fail to build another.

Yes, I started looking into build code - it does nasty things not documented
anywhere. IIRC, it, for example, discards CPPFLAGS, even though 'configure' help
message traditionally says the environment variable is supported.
Comment 97 Sergei Steshenko 2010-02-05 19:02:00 UTC
(In reply to comment #96)
> I very carefully consider behavior of those whom I might help. Developers of
> 'glibc' are absolutely no freaking way such people - because first and foremost
> they are not ready to admit they have bugs.
> 
> Regarding "Building glibc properly is a complex operation with many particular
> dependencies" - let me translate it for you: build documentation is of
> unbelievably low quality. It was enough for me to discover that having _exactly_
> the same settings (i.e. both dependencies and command line options) I can
> successfully build one 'glibc' version and fail to build another.
> 
> Yes, I started looking into build code - it does nasty things not documented
> anywhere. IIRC, it, for example, discards CPPFLAGS, even though 'configure' help
> message traditionally says the environment variable is supported.

You know what, I've played with 'glibc' a little bit more and decided that maybe
I'm too harsh on 'glibc' developers.

So, upon uncovering new facts I want to perform a test, or, rather, even two
tests of 'glibc' developers' honesty, courage (to admit existence of bugs) and
integrity.

The tests consist of making simple statements regarding my build environment and
observed behavior, and asking question WRT the environment and behavior. If
'glibc' developers answer the questions honestly, then I was too harsh.

Here are the tests.

Test 1 BEGIN.

I've played with the following 'glibc' versions: 2.9, 2.10.1, 2.11.1.

While playing with them I had _exactly_ the same build environment, i.e. exactly
the same versions of tools and libraries needed to build 'glibc'.

I also used the same command lines to run 'configure' - except for prefix.

'configure' command line was of the following kind:

./configure  CC="/actual/path/to/gcc" CFLAGS='-march=native -mtune=native -g
-O2' --with-binutils=/path/to/binutils --prefix=/some/common/dir/INSTALL_SUBDIR

, i.e. the only variable part was INSTALL_SUBDIR.

I am pretty sure that build environment is exactly the same for all three cases
because the build is done by a tool of mine, so no manual actions are involved -
except for changing 'glibc' version in the configuration file.

If anybody is interested, I can provide the tool, it's open source (GPL + LGPL +
Artistic licenses) and it builds and installs everything _not_requiring root
permission, so your systems are safe.


For some of the versions 'configure' fails, and for some - not. Rest assured
that the needed utilities are quite new.

The question: is it normal that 'configure' fails for some 'glibc' versions and
not the others ?

If you intend to answer the question, here's two pieces of additional info:

1) if 'configure' doesn't fail, 'make' is also OK;
2) I am warning you in advance that the problem is in 'glibc' build system, and
it looks like you, the developers, have already fixed it, so the question really
is: "Are you, 'glibc' developers, ready to admit that your build system _does_
have bugs - at least from time to time ?".

Test 1 END.


Test 2 BEGIN.

glibc-2.11.1 comes with a file called FAQ, and an interesting item in the FAQ is:

"
1.16.   I get failures during `make check'.  What should I do?

{AJ} The testsuite should compile and run cleanly on your system; every
failure should be looked into.  Depending on the failures, you probably
should not install the library at all.

You should consider reporting it in bugzilla
<http://sourceware.org/bugzilla/> providing as much detail as possible.
If you run a test directly, please remember to set up the environment
correctly. You want to test the compiled library - and not your installed
one. The best way is to copy the exact command line which failed and run
the test from the subdirectory for this test in the sources.

There are some failures which are not directly related to the GNU libc:
- Some compilers produce buggy code.  No compiler gets single precision
  complex numbers correct on Alpha.  Otherwise, gcc-3.2 should be ok.
- The kernel might have bugs.  For example on Linux/Alpha 2.0.34 the
  floating point handling has quite a number of bugs and therefore most of
  the test cases in the math subdirectory will fail.  Linux 2.2 has
  fixes for the floating point support on Alpha.  The Linux/SPARC kernel has
  also some bugs in the FPU emulation code (as of Linux 2.2.0).
- Other tools might have problems.  For example bash 2.03 gives a
  segmentation fault running the tst-rpmatch.sh test script.
".

I managed to build some versions of 'glibc' using the standard

./configure ...
make

sequence, and, as stated above, the environment is generated automatically, i.e.
ultimately by 'configure'. Still, 'make check' fails. I.e. 'configure' either
doesn't check all that needs to be checked, or there are problems somewhere
else in the build mechanism.

The question:

if I _do_ file a bug report as the FAQ suggests, will you consider it in detail
or just mark the bug report as duplicate of this one ?

A similar to the above warning: I am pretty sure it's a bug in 'glibc' build
mechanism, i.e. I am pretty sure what build mechanism fails to do what it needs
to do, and I need to better confirm my findings by trying to work around the
problem in the build mechanism.

Other build mechanisms behave correctly under similar circumstances.

Test 2 END.
Comment 98 joseph@codesourcery.com 2010-02-05 20:45:19 UTC
Subject: Re:  Do not report build errors in bugzilla!

Build problems generally have extremely complicated dependence on the 
exact details of the build environment, such that it is effectively 
impossible to debug them without access to that environment; attempting to 
debug one by mail would likely involve dozens of questions back and forth 
asking for details of logs, of the effects of particular changes or of 
other aspects of the environment, and hours of wasted time.  Instead, if 
you have a build problem you should trace it through the build system 
yourself and send a report with a detailed analysis of the cause of the 
failure and why it indicates a glibc bug, so that readers can understand 
the analysis without needing access to your system.

> ./configure  CC="/actual/path/to/gcc" CFLAGS='-march=native -mtune=native -g
> -O2' --with-binutils=/path/to/binutils --prefix=/some/common/dir/INSTALL_SUBDIR

Using --prefix other than --prefix=/usr is an extremely unusual 
configuration that is unlikely to be well-tested.

> The question: is it normal that 'configure' fails for some 'glibc' versions and
> not the others ?

It is normal to have complicated dependencies on your environment, which 
may also involve dependencies on the glibc version.  "fails" is never a 
useful bug report; a useful one would be along the lines of "configure 
test X produces error Y because command A produces result B, whereas for 
previous version N command A' is run instead, and distribution builds of 
version P do not see the problem because they are configuring with version 
Q of command A and with different configure option W; by making change V 
the problem would be avoided without affecting the options used in the 
distribution builds".

Comment 99 Sergei Steshenko 2010-02-06 00:01:03 UTC
(In reply to comment #98)
> Subject: Re:  Do not report build errors in bugzilla!
> 
> Build problems generally have extremely complicated dependence on the 
> exact details of the build environment, such that it is effectively 
> impossible to debug them without access to that environment; attempting to 
> debug one by mail would likely involve dozens of questions back and forth 
> asking for details of logs, of the effects of particular changes or of 
> other aspects of the environment, and hours of wasted time.  Instead, if 
> you have a build problem you should trace it through the build system 
> yourself and send a report with a detailed analysis of the cause of the 
> failure and why it indicates a glibc bug, so that readers can understand 
> the analysis without needing access to your system.
> 
> > ./configure  CC="/actual/path/to/gcc" CFLAGS='-march=native -mtune=native -g
> > -O2' --with-binutils=/path/to/binutils --prefix=/some/common/dir/INSTALL_SUBDIR
> 
> Using --prefix other than --prefix=/usr is an extremely unusual 
> configuration that is unlikely to be well-tested.
> 
> > The question: is it normal that 'configure' fails for some 'glibc' versions and
> > not the others ?
> 
> It is normal to have complicated dependencies on your environment, which 
> may also involve dependencies on the glibc version.  "fails" is never a 
> useful bug report; a useful one would be along the lines of "configure 
> test X produces error Y because command A produces result B, whereas for 
> previous version N command A' is run instead, and distribution builds of 
> version P do not see the problem because they are configuring with version 
> Q of command A and with different configure option W; by making change V 
> the problem would be avoided without affecting the options used in the 
> distribution builds".
> 
> 

You make me laugh a lot.

For example, you wrote:

"
Using --prefix other than --prefix=/usr is an extremely unusual
configuration that is unlikely to be well-tested.
".

Let me translate it into normal English: 'glibc' build mechanism is crap, nobody
even bothered to make it compliant with GNU autools guidelines, nobody even
bothered to test it properly, _nobody_ _even_ _bothered_ _to_ _write_ _this_
_in_documentation_. Now look at this:

"
qemu@amdam2:/mnt/sdb8/sergei/AFSWD_debug> ls -ltrD install/
  total 317
  drwxr-xr-x  5 qemu users 1024 2009-12-29 05:12 m4-1.4.13
  drwxr-xr-x  8 qemu users 1024 2009-12-29 05:15 ncurses-5.7
  drwxr-xr-x  5 qemu users 1024 2009-12-29 05:16 texinfo-4.13
  drwxr-xr-x  5 qemu users 1024 2009-12-29 05:31 autoconf-2.65
  drwxr-xr-x  6 qemu users 1024 2009-12-29 05:33 bison-2.4.1
  drwxr-xr-x  6 qemu users 1024 2009-12-29 05:34 readline-6.0
  drwxr-xr-x  5 qemu users 1024 2009-12-29 05:37 bash-4.0
  drwxr-xr-x  5 qemu users 1024 2009-12-29 05:38 pkg-config-0.23
  drwxr-xr-x  5 qemu users 1024 2009-12-29 05:39 gperf-3.0.4
  drwxr-xr-x  5 qemu users 1024 2009-12-29 06:13 automake-1.10.3
  drwxr-xr-x  6 qemu users 1024 2009-12-29 06:13 zlib-1.2.3
  drwxr-xr-x  7 qemu users 1024 2009-12-29 06:28 libtool-2.2.6b
  drwxr-xr-x  7 qemu users 1024 2009-12-29 06:30 libiconv_pre-1.13.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 06:48 gettext-0.17
  drwxr-xr-x  6 qemu users 1024 2009-12-29 06:57 gmp-4.3.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 07:04 tcl-8.4.19
  drwxr-xr-x  7 qemu users 1024 2009-12-29 07:05 tk-8.4.19
  drwxr-xr-x  6 qemu users 1024 2009-12-29 07:06 expect-5.44.1.14
  drwxr-xr-x  7 qemu users 1024 2009-12-29 07:06 dejagnu-1.4.4
  drwxr-xr-x  9 qemu users 1024 2009-12-29 07:08 flex-2.5.35
  drwxr-xr-x  6 qemu users 1024 2009-12-29 07:10 mpfr-2.4.2
  drwxr-xr-x 10 qemu users 1024 2009-12-29 10:34 gcc-4.4.2
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:35 HTML-Tagset-3.20
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:35 HTML-Parser-3.64
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:35 URI-1.40
  drwxr-xr-x  6 qemu users 1024 2009-12-29 10:36 libwww-perl-5.833
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:38 ExtUtils-Depends-0.302
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:38 ExtUtils-PkgConfig-1.11
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:38 expat-2.0.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:39 freetype-2.3.9
  drwxr-xr-x  9 qemu users 1024 2009-12-29 10:40 fontconfig-2.7.3
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:40 libpng-1.2.40
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:41 pixman-0.12.0
  drwxr-xr-x  6 qemu users 1024 2009-12-29 10:50 cairo-1.8.8
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:51 jpegsrc.v6b
  drwxr-xr-x  5 qemu users 1024 2009-12-29 10:51 Cairo-1.061
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:53 libiconv-1.11
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:53 pcre-7.9
  drwxr-xr-x  7 qemu users 1024 2009-12-29 10:59 glib-2.20.5
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:00 libIDL-0.8.13
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:03 libxml2-2.7.6
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:05 ORBit2-2.14.17
  drwxr-xr-x  5 qemu users 1024 2009-12-29 11:05 XML-Parser-2.36
  drwxr-xr-x 10 qemu users 1024 2009-12-29 11:11 dbus-1.2.16
  drwxr-xr-x  9 qemu users 1024 2009-12-29 11:11 dbus-glib-0.82
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:12 atk-1.22.0
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:23 bc-1.06
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:26 openssl-0.9.8l
  drwxr-xr-x  8 qemu users 1024 2009-12-29 11:28 pango-1.26.0
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:39 popt-1.15
  drwxr-xr-x  5 qemu users 1024 2009-12-29 11:40 Glib-1.222
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:40 bzip2-1.0.5
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:40 gnome-mime-data-2.18.0
  drwxr-xr-x 10 qemu users 1024 2009-12-29 11:42 libbonobo-2.22.0
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:48 gstreamer-0.10.25
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:49 liboil-0.3.16
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:49 libogg-1.1.4
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:50 libvorbis-1.2.3
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:50 libart_lgpl-2.3.20
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:51 audiofile-0.2.6
  drwxr-xr-x  8 qemu users 1024 2009-12-29 11:51 esound-0.2.38
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:52 libgpg-error-1.7
  drwxr-xr-x  8 qemu users 1024 2009-12-29 11:56 libgcrypt-1.4.5
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:57 libtasn1-2.2
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:57 jbig2dec-0.9
  drwxr-xr-x  6 qemu users 1024 2009-12-29 11:58 gd-2.0.35
  drwxr-xr-x  7 qemu users 1024 2009-12-29 11:58 jbigkit-1.6
  drwxr-xr-x  5 qemu users 1024 2009-12-29 11:59 libfpx-1.3.0-0
  drwxr-xr-x  6 qemu users 1024 2009-12-29 12:00 libcroco-0.6.1
  drwxr-xr-x  8 qemu users 1024 2009-12-29 12:01 libgsf-1.14.8
  drwxr-xr-x  7 qemu users 1024 2009-12-29 12:02 mpeg2dec-0.4.1
  drwxr-xr-x  4 qemu users 1024 2009-12-29 12:02 mpeg2vidcodec_v12
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:03 ilmbase-1.0.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 12:09 openexr-1.6.1
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:09 XML-LibXML-Common-0.13
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:09 XML-NamespaceSupport-1.10
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:09 XML-SAX-0.96
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:10 XML-LibXML-1.70
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:10 XML-Simple-2.18
  drwxr-xr-x  7 qemu users 1024 2009-12-29 12:12 libxslt-1.1.24
  drwxr-xr-x  6 qemu users 1024 2009-12-29 12:12 Module-Build-0.2805
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:12 Module-Pluggable-3.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 12:13 SDL-1.2.14
  drwxr-xr-x  6 qemu users 1024 2009-12-29 12:15 c-ares-1.7.0
  drwxr-xr-x  5 qemu users 1024 2009-12-29 12:16 lzo-2.03
  drwxr-xr-x  6 qemu users 1024 2009-12-29 12:19 opencdk-0.6.6
  drwxr-xr-x  7 qemu users 1024 2009-12-29 12:30 aspell-0.60.6
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-am-0.03-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-ar-1.2-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-az-0.02-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-bg-4.1-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-bn-0.01.1-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-ca-20040130-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-cs-20040614-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-csb-0.02-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-de-20030222-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-de-alt-2.1-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-en-6.0-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-eo-2.1.20000225a-2
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-es-1.9a-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-et-0.1.21-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-fa-0.11-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-fi-0.7-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:30 aspell6-fy-0.12-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-gl-0.5a-2
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-gu-0.03-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-he-1.0-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-hi-0.02-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-hsb-0.01-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-hu-0.99.4.2-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-hy-0.10.0-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-it-2.2_20050523-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-la-20020503-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-lt-1.2.1-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-lv-0.5.5-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-ml-0.03-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-mn-0.06-2
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-mr-0.10-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-nds-0.01-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-pa-0.01-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-or-0.03-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-pl-6.0_20061121-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-pt_BR-20080707-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-pt_PT-20070510-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-qq-0.03-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-qu-0.02-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-ru-0.99f7-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-sk-2.00-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-sr-0.02
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:31 aspell6-ta-20040424-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:32 aspell6-te-0.01-2
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:32 aspell6-uk-1.4.0-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:32 aspell6-uz-0.6-0
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:32 aspell6-vi-0.01.1-1
  drwxr-xr-x  3 qemu users 1024 2009-12-29 12:32 aspell6-yi-0.01.1-1
  drwxr-xr-x  5 qemu users 1024 2009-12-29 13:04 cabextract-1.2
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:05 enchant-1.4.2
  drwxr-xr-x  8 qemu users 1024 2009-12-29 13:05 pth-2.0.7
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:06 libassuan-1.0.5
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:06 libksba-1.0.7
  drwxr-xr-x  6 qemu users 1024 2009-12-29 13:31 coreutils-8.2
  drwxr-xr-x  8 qemu users 1024 2009-12-29 13:39 flac-1.2.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:39 libraw1394-2.0.4
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:39 libavc1394-0.5.3
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:39 libiec61883-1.2.0
  drwxr-xr-x  5 qemu users 1024 2009-12-29 13:41 libfreebob-1.0.11
  drwxr-xr-x  6 qemu users 1024 2009-12-29 13:41 libao-0.8.8
  drwxr-xr-x  7 qemu users 1024 2009-12-29 13:42 speex-1.1.12
  drwxr-xr-x  5 qemu users 1024 2009-12-29 13:42 pa_snapshot_v18
  drwxr-xr-x  5 qemu users 1024 2009-12-29 13:43 libid3tag-0.15.1b
  drwxr-xr-x  5 qemu users 1024 2009-12-29 13:43 libmad-0.15.1b
  drwxr-xr-x  6 qemu users 1024 2009-12-29 13:44 wavpack-4.50.1
  drwxr-xr-x  6 qemu users 1024 2009-12-29 15:24 libungif4_4.1.4.orig
  drwxr-xr-x  5 qemu users 1024 2009-12-29 15:25 potrace-1.7
  drwxr-xr-x  9 qemu users 1024 2009-12-29 15:49 scrollkeeper-0.3.14
  drwxr-xr-x  9 qemu users 1024 2009-12-29 15:49 glib-1.2.10
  drwxr-xr-x 10 qemu users 1024 2009-12-29 16:39 gtk+-1.2.10
  drwxr-xr-x  9 qemu users 1024 2009-12-29 16:58 icu4c-3_6-src
  drwxr-xr-x  3 qemu users 1024 2009-12-29 16:58 kqemu-1.4.0pre1
  drwxr-xr-x  8 qemu users 1024 2009-12-29 17:02 lesstif-0.95.0
  drwxr-xr-x  6 qemu users 1024 2009-12-29 17:03 libosip2-3.1.0
  drwxr-xr-x  8 qemu users 1024 2009-12-29 17:05 libgii-1.0.2
  drwxr-xr-x  8 qemu users 1024 2009-12-29 17:09 libggi-2.2.2
  drwxr-xr-x  7 qemu users 1024 2009-12-29 17:10 libggigcp-1.0.2
  drwxr-xr-x  7 qemu users 1024 2009-12-29 17:10 libggimisc-2.2.2
  drwxr-xr-x  7 qemu users 1024 2009-12-29 17:11 libggiwmh-0.3.2
  drwxr-xr-x  8 qemu users 1024 2009-12-29 17:11 libgiigic-1.1.2
  drwxr-xr-x  7 qemu users 1024 2009-12-29 17:12 libidn-1.15
  drwxr-xr-x  8 qemu users 1024 2009-12-29 17:13 libmcrypt-2.5.8
  drwxr-xr-x  6 qemu users 1024 2009-12-29 17:13 madplay-0.15.2b
  drwxr-xr-x  7 qemu users 1024 2009-12-29 17:14 make-3.80
  drwxr-xr-x  6 qemu users 1024 2009-12-29 17:15 mhash-0.9.9
  drwxr-xr-x  5 qemu users 1024 2009-12-29 17:15 mcrypt-2.6.8
  drwxr-xr-x  4 qemu users 1024 2009-12-29 17:16 nedit-5.5-src
  drwxr-xr-x  5 qemu users 1024 2009-12-29 17:19 ortp-0.13.1
  drwxr-xr-x  6 qemu users 1024 2009-12-29 18:26 ladspa_sdk
  drwxr-xr-x  7 qemu users 1024 2009-12-29 18:46 MesaLib-7.6.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 18:48 tiff-3.9.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 18:51 jasper-1.900.1
  drwxr-xr-x  7 qemu users 1024 2009-12-29 19:15 lcms-1.19
  drwxr-xr-x  5 qemu users 1024 2009-12-29 19:15 dcraw-8.99
  drwxr-xr-x  7 qemu users 1024 2009-12-29 19:17 djvulibre-3.5.22
  drwxr-xr-x  7 qemu users 1024 2009-12-29 19:41 fltk-1.1.9-source
  drwxr-xr-x  7 qemu users 1024 2009-12-29 19:46 fontforge-20090622
  drwxr-xr-x  7 qemu users 1024 2009-12-29 22:01 wine-1.1.35
  drwxr-xr-x  7 qemu users 1024 2009-12-29 22:08 wxX11-2.8.10
  drwxr-xr-x  5 qemu users 1024 2009-12-29 22:47 intltool-0.40.6
  drwxr-xr-x  6 qemu users 1024 2009-12-29 23:59 gnome-doc-utils-0.18.1
  drwxr-xr-x  8 qemu users 1024 2010-01-04 04:57 pango-1.26.2
  drwxr-xr-x  5 qemu users 1024 2010-01-04 05:26 Pango-1.221
  drwxr-xr-x  6 qemu users 1024 2010-01-22 22:41 coreutils-8.4
  drwxr-xr-x  7 qemu users 1024 2010-01-23 20:41 ginac-1.5.4
  drwxr-xr-x  6 qemu users 1024 2010-01-23 21:16 glpk-4.32
  drwxr-xr-x  5 qemu users 1024 2010-01-27 21:42 grep-2.5.4
  drwxr-xr-x  7 qemu users 1024 2010-01-27 23:02 findutils-4.4.2
  drwxr-xr-x  6 qemu users 1024 2010-01-27 23:23 gawk-3.1.7
  drwxr-xr-x  6 qemu users 1024 2010-01-29 02:57 readline-6.1
  drwxr-xr-x  5 qemu users 1024 2010-01-29 02:59 bash-4.1
  drwxr-xr-x  7 qemu users 1024 2010-01-29 03:02 guile-1.8.7
  drwxr-xr-x  7 qemu users 1024 2010-01-29 03:03 autogen-5.10
  drwxr-xr-x 10 qemu users 1024 2010-01-29 06:35 gcc-4.4.3
  drwxr-xr-x  5 qemu users 1024 2010-01-29 06:35 metis-4.0
  drwxr-xr-x  5 qemu users 1024 2010-01-29 06:35 UFconfig-3.1.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 06:35 AMD-2.2.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 06:35 CAMD-2.2.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 06:36 CCOLAMD-2.7.1
  drwxr-xr-x  6 qemu users 1024 2010-01-29 06:36 COLAMD-2.7.1
  drwxr-xr-x  5 qemu users 1024 2010-01-29 06:37 CHOLMOD-1.6.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 06:37 CXSparse-2.2.1
  drwxr-xr-x  4 qemu users 1024 2010-01-29 07:05 blas_generic
  drwxr-xr-x  6 qemu users 1024 2010-01-29 07:06 UMFPACK-5.2.0
  drwxr-xr-x  7 qemu users 1024 2010-01-29 07:09 gnutls-2.8.5
  drwxr-xr-x  5 qemu users 1024 2010-01-29 07:15 aria2-1.8.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 07:24 lapack-3.2.1
  drwxr-xr-x  5 qemu users 1024 2010-01-29 09:56 atlas-3.8.3
  drwxr-xr-x 10 qemu users 1024 2010-01-29 10:01 binutils-2.19.1
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:05 binutils_mingw32-2.20
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:07 gnupg-2.0.13
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:16 ffcall-1.10
  drwxr-xr-x  5 qemu users 1024 2010-01-29 10:16 libsigsegv-2.8
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:44 cln-1.3.1
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:50 curl-7.19.7
  drwxr-xr-x  5 qemu users 1024 2010-01-29 10:50 vorbis-tools-1.2.0
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:52 libsndfile-1.0.21
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:54 jack-audio-connection-kit-0.109.2
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:55 lame-398-2
  drwxr-xr-x  6 qemu users 1024 2010-01-29 10:56 libsamplerate-0.1.7
  drwxr-xr-x  7 qemu users 1024 2010-01-29 10:57 mpg123-1.10.0
  drwxr-xr-x  7 qemu users 1024 2010-01-29 11:03 ecasound-2.6.0
  drwxr-xr-x  7 qemu users 1024 2010-01-29 11:09 ffmpeg-0.5
  drwxr-xr-x 10 qemu users 1024 2010-01-29 12:21 gcc-3.4.6
  drwxr-xr-x  6 qemu users 1024 2010-01-29 12:24 fftw-2.1.5
  drwxr-xr-x  7 qemu users 1024 2010-01-29 12:28 fftw3-3.2.2
  drwxr-xr-x  7 qemu users 1024 2010-01-29 12:33 fftw3_sse-3.2.2
  drwxr-xr-x  7 qemu users 1024 2010-01-29 12:38 fftw3_sse2-3.2.2
  drwxr-xr-x  7 qemu users 1024 2010-01-29 12:58 ginac-1.5.6
  drwxr-xr-x 10 qemu users 1024 2010-01-29 13:33 glibc-2.9
  drwxr-xr-x  6 qemu users 1024 2010-01-29 13:34 glpk-4.42
  drwxr-xr-x  7 qemu users 1024 2010-01-29 13:42 gsl-1.13
  drwxr-xr-x  7 qemu users 1024 2010-01-29 13:42 harminv-1.3.1
  drwxr-xr-x  5 qemu users 1024 2010-01-29 13:43 szip-2.1
  drwxr-xr-x  7 qemu users 1024 2010-01-29 14:39 netcdf-3.6.2
  drwxr-xr-x  6 qemu users 1024 2010-01-29 14:39 normalize-0.7.7
  drwxr-xr-x  8 qemu users 1024 2010-01-29 14:40 qhull-2003.1
  drwxr-xr-x  7 qemu users 1024 2010-01-29 15:55 pd_fftw2-0.41-4
  drwxr-xr-x  5 qemu users 1024 2010-01-29 16:28 qemu-0.10.6
  drwxr-xr-x  5 qemu users 1024 2010-01-29 16:28 rlwrap-0.36
  drwxr-xr-x  7 qemu users 1024 2010-01-29 16:31 sox-14.3.0
  drwxr-xr-x  4 qemu users 1024 2010-01-29 16:33 spiral-may04
  drwxr-xr-x  7 qemu users 1024 2010-01-29 18:24 openssl-1.0.0-beta5
  drwxr-xr-x 10 qemu users 1024 2010-01-29 18:26 cups-1.3.11-source
  drwxr-xr-x  8 qemu users 1024 2010-01-29 18:39 gtk+-2.16.6
  drwxr-xr-x  9 qemu users 1024 2010-01-29 18:41 GConf-2.22.0
  drwxr-xr-x  9 qemu users 1024 2010-01-29 18:45 gnome-vfs-2.24.2
  drwxr-xr-x  7 qemu users 1024 2010-01-29 18:56 gst-plugins-base-0.10.25
  drwxr-xr-x  5 qemu users 1024 2010-01-29 18:57 GStreamer-0.15
  drwxr-xr-x  5 qemu users 1024 2010-01-29 19:02 Gtk2-1.221
  drwxr-xr-x  6 qemu users 1024 2010-01-29 19:04 gail-1.22.3
  drwxr-xr-x  7 qemu users 1024 2010-01-29 19:04 libglade-2.6.2
  drwxr-xr-x  6 qemu users 1024 2010-01-29 19:06 libgnomecanvas-2.26.0
  drwxr-xr-x  5 qemu users 1024 2010-01-29 19:06 Gnome2-Canvas-1.002
  drwxr-xr-x  5 qemu users 1024 2010-01-29 19:07 Gnome2-VFS-1.080
  drwxr-xr-x  8 qemu users 1024 2010-01-29 19:08 libgnome-2.28.0
  drwxr-xr-x  7 qemu users 1024 2010-01-29 19:12 libbonoboui-2.24.2
  drwxr-xr-x  9 qemu users 1024 2010-01-29 19:14 gnome-keyring-2.28.1
  drwxr-xr-x  6 qemu users 1024 2010-01-29 19:18 libgnomeui-2.24.2
  drwxr-xr-x  5 qemu users 1024 2010-01-29 19:19 Gnome2-1.040
  drwxr-xr-x  6 qemu users 1024 2010-01-29 19:25 ghostscript-8.70
  drwxr-xr-x  7 qemu users 1024 2010-01-29 19:33 graphviz-2.24.0
  drwxr-xr-x  8 qemu users 1024 2010-01-29 19:34 librsvg-2.26.0
  drwxr-xr-x  7 qemu users 1024 2010-01-29 19:36 libwmf-0.2.8.4
  drwxr-xr-x  7 qemu users 1024 2010-01-29 19:52 ImageMagick-6.5.7-10
  drwxr-xr-x  6 qemu users 1024 2010-01-29 19:55 libgnomecups-0.2.3
  drwxr-xr-x  6 qemu users 1024 2010-01-29 19:58 libgnomeprint-2.18.6
  drwxr-xr-x  6 qemu users 1024 2010-01-29 20:02 diacanvas2-0.14.4
  drwxr-xr-x  7 qemu users 1024 2010-01-29 20:25 ImageMagick-6.5.8-10
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:25 icon-naming-utils-0.8.90
  drwxr-xr-x  4 qemu users 1024 2010-01-29 20:27 gnome-icon-theme-2.28.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 20:29 libgnomeprintui-2.18.4
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:30 Gnome2-Print-1.000
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:31 Gnome2-Dia-0.04
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:31 Gnome2-GConf-1.043
  drwxr-xr-x  8 qemu users 1024 2010-01-29 20:33 vte-0.16.14
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:34 Gnome2-Vte-0.09
  drwxr-xr-x  6 qemu users 1024 2010-01-29 20:35 libwnck-2.14.2
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:35 Gnome2-Wnck-0.13
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:36 Gtk2-GladeXML-1.006
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:39 libgtkhtml-2.6.3
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:39 Gtk2-Html2-0.04
  drwxr-xr-x  5 qemu users 1024 2010-01-29 20:39 Gtk2-TrayIcon-0.04
  drwxr-xr-x  8 qemu users 1024 2010-01-29 20:41 at-spi-1.28.1
  drwxr-xr-x  6 qemu users 1024 2010-01-29 20:45 libetpan-0.58
  drwxr-xr-x  7 qemu users 1024 2010-01-29 20:51 claws-mail-3.7.3
  drwxr-xr-x  6 qemu users 1024 2010-01-29 21:07 clisp-2.48
  drwxr-xr-x  7 qemu users 1024 2010-01-29 21:11 glade3-3.6.7
  drwxr-xr-x  7 qemu users 1024 2010-01-29 21:27 wxGTK-2.8.10
  drwxr-xr-x  7 qemu users 1024 2010-01-29 21:28 gnuplot-4.2.6
  drwxr-xr-x  7 qemu users 1024 2010-01-29 21:30 gnuplot-4.3.0-2009-07-08
  drwxr-xr-x  6 qemu users 1024 2010-01-29 21:40 gst-plugins-good-0.10.17
  drwxr-xr-x  5 qemu users 1024 2010-01-29 21:42 gtk-engines-2.14.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 21:43 gtkspell-2.0.16
  drwxr-xr-x  6 qemu users 1024 2010-01-29 21:53 hdf5-1.8.1
  drwxr-xr-x  6 qemu users 1024 2010-01-29 21:54 libeXosip2-3.1.0
  drwxr-xr-x  6 qemu users 1024 2010-01-29 22:35 sbcl-1.0.34
  drwxr-xr-x  8 qemu users 1024 2010-01-29 23:28 octave-3.0.5
  drwxr-xr-x  3 qemu users 1024 2010-01-29 23:59 octave-forge-bundle-20080831
  drwxr-xr-x  8 qemu users 1024 2010-01-30 00:09 pidgin-2.6.1
  drwxr-xr-x  5 qemu users 1024 2010-01-30 00:11 pjproject-1.4.5
  drwxr-xr-x  7 qemu users 1024 2010-01-30 01:06 wine-1.1.37
  drwxr-xr-x  5 qemu users 1024 2010-02-04 00:44 aria2-1.8.2
  drwxr-xr-x  6 qemu users 1024 2010-02-05 01:46 sbcl-1.0.35
  drwxr-xr-x  5 qemu users 1024 2010-02-05 02:10 fricas-1.0.9
  drwxr-xr-x  9 qemu users 1024 2010-02-05 02:24 maxima-5.20.1
  drwxr-xr-x  5 qemu users 1024 2010-02-05 02:29 wxMaxima-0.8.4
  drwxr-xr-x  8 qemu users 1024 2010-02-05 19:23 binutils-2.20
  drwxr-xr-x 10 qemu users 1024 2010-02-05 20:45 glibc-2.10.1
  drwxr-xr-x 10 qemu users 1024 2010-02-06 01:23 glibc-2.11.1
"

- there are altogether 317 targets (including, by the way, glibc) built using
'--prefix=....' command. How is that that, say, 300 targets authors do support
'--prefix=', and 'glibc' authors do not ?

You wrote:

"
fails" is never a useful bug report
".

Of course it isn't. But what sense does it make to write useful bug reports if
they are never considered/analyzed by the developers and are automatically
qualified as duplicate of this infamous bug #333 ? Don't you see a chicken <->
egg problem here ?

You wrote:

"
Build problems generally have extremely complicated dependence on the
exact details of the build environment, such that it is effectively
impossible to debug them without access to that environment; attempting to
debug one by mail would likely involve dozens of questions back and forth
asking for details of logs
".

Sorry, but this is nonsense regarding _my_ bug reports. Whenever I file a bug
report, I first of all send all the relevant logs, and I _always_ offer to use
my AppsFromScratch to reproduce the problem. I offered it again in my previous
comment - one command line, disk space, some time, and one has everything.

And 'glibc' is the only place where I see this attitude - I have filed
"countless" amount of bug reports against build mechanisms, and they all were
considered and the problems were somehow fixed.

Here is, for example, copy-pasted automatically 'configure' wrapper I've just
used to rebuild 'glibc':

"
cat -n build/glibc-2.11.1/config_wrapper.sh
     1  #!/bin/sh
     2
     3  cd /mnt/sdb8/sergei/AFSWD_debug/build/glibc-2.11.1
     4
     5 
PATH=/mnt/sdb8/sergei/AFSWD_debug/install/autoconf-2.65/bin:/mnt/sdb8/sergei/AFSWD_debug/install/autogen-5.10/bin:/mnt/sdb8/sergei/AFSWD_debug/install/automake-1.10.3/bin:/mnt/sdb8/sergei/AFSWD_debug/install/binutils-2.19.1/bin:/mnt/sdb8/sergei/AFSWD_debug/install/bison-2.4.1/bin:/mnt/sdb8/sergei/AFSWD_debug/install/dejagnu-1.4.4/bin:/mnt/sdb8/sergei/AFSWD_debug/install/expect-5.44.1.14/bin:/mnt/sdb8/sergei/AFSWD_debug/install/flex-2.5.35/bin:/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/bin:/mnt/sdb8/sergei/AFSWD_debug/install/gettext-0.17/bin:/mnt/sdb8/sergei/AFSWD_debug/install/gperf-3.0.4/bin:/mnt/sdb8/sergei/AFSWD_debug/install/guile-1.8.7/bin:/mnt/sdb8/sergei/AFSWD_debug/install/libiconv_pre-1.13.1/bin:/mnt/sdb8/sergei/AFSWD_debug/install/libtool-2.2.6b/bin:/mnt/sdb8/sergei/AFSWD_debug/install/m4-1.4.13/bin:/mnt/sdb8/sergei/AFSWD_debug/install/ncurses-5.7/bin:/mnt/sdb8/sergei/AFSWD_debug/install/tcl-8.4.19/bin:/mnt/sdb8/sergei/AFSWD_debug/install/texinfo-4.13/bin:/mnt/sdb8/sergei/AFSWD_debug/install/tk-8.4.19/bin:/mnt/sdb8/sergei/AFSWD_debug/install/pkg-config-0.23/bin:/home/sergei/mingwi686/bin:/opt/kde3/bin:/home/sergei/bin:/usr/local/bin:/usr/bin:/bin:/usr/bin/X11:/usr/X11R6/bin:/usr/games:/usr/lib/jvm/jre/bin:/usr/lib/mit/bin:/usr/lib/mit/sbin
     6  export PATH
     7
     8 
LD_LIBRARY_PATH=/mnt/sdb8/sergei/AFSWD_debug/install/autogen-5.10/lib:/mnt/sdb8/sergei/AFSWD_debug/install/binutils-2.19.1/lib:/mnt/sdb8/sergei/AFSWD_debug/install/bison-2.4.1/lib:/mnt/sdb8/sergei/AFSWD_debug/install/flex-2.5.35/lib:/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/lib:/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/lib/gcc/i686-pc-linux-gnu/4.4.3:/mnt/sdb8/sergei/AFSWD_debug/install/gettext-0.17/lib:/mnt/sdb8/sergei/AFSWD_debug/install/gmp-4.3.1/lib:/mnt/sdb8/sergei/AFSWD_debug/install/guile-1.8.7/lib:/mnt/sdb8/sergei/AFSWD_debug/install/libiconv_pre-1.13.1/lib:/mnt/sdb8/sergei/AFSWD_debug/install/libtool-2.2.6b/lib:/mnt/sdb8/sergei/AFSWD_debug/install/mpfr-2.4.2/lib:/mnt/sdb8/sergei/AFSWD_debug/install/ncurses-5.7/lib:/mnt/sdb8/sergei/AFSWD_debug/install/readline-6.1/lib:/mnt/sdb8/sergei/AFSWD_debug/install/tcl-8.4.19/lib:/mnt/sdb8/sergei/AFSWD_debug/install/tcl-8.4.19/lib/expect5.44.1.14:/mnt/sdb8/sergei/AFSWD_debug/install/tk-8.4.19/lib:/mnt/sdb8/sergei/AFSWD_debug/install/zlib-1.2.3/lib
     9  export LD_LIBRARY_PATH
    10
    11 
PKG_CONFIG_PATH=/mnt/sdb8/sergei/AFSWD_debug/install/guile-1.8.7/lib/pkgconfig:/mnt/sdb8/sergei/AFSWD_debug/install/autogen-5.10/lib/pkgconfig:/usr/lib/pkgconfig
    12  export PKG_CONFIG_PATH
    13
    14  LDFLAGS='-L/mnt/sdb8/sergei/AFSWD_debug/install/autogen-5.10/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/binutils-2.19.1/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/bison-2.4.1/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/flex-2.5.35/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/lib/gcc/i686-pc-linux-gnu/4.4.3
-L/mnt/sdb8/sergei/AFSWD_debug/install/gettext-0.17/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/gmp-4.3.1/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/guile-1.8.7/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/libiconv_pre-1.13.1/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/libtool-2.2.6b/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/mpfr-2.4.2/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/ncurses-5.7/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/readline-6.1/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/tcl-8.4.19/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/tcl-8.4.19/lib/expect5.44.1.14
-L/mnt/sdb8/sergei/AFSWD_debug/install/tk-8.4.19/lib
-L/mnt/sdb8/sergei/AFSWD_debug/install/zlib-1.2.3/lib'
    15  export LDFLAGS
    16
    17  CPPFLAGS='-I/mnt/sdb8/sergei/AFSWD_debug/install/autoconf-2.65/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/autogen-5.10/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/automake-1.10.3/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/binutils-2.19.1/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/bison-2.4.1/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/dejagnu-1.4.4/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/expect-5.44.1.14/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/flex-2.5.35/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/gettext-0.17/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/gmp-4.3.1/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/gperf-3.0.4/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/guile-1.8.7/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/libiconv_pre-1.13.1/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/libtool-2.2.6b/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/m4-1.4.13/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/mpfr-2.4.2/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/ncurses-5.7/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/readline-6.1/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/tcl-8.4.19/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/texinfo-4.13/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/tk-8.4.19/include
-I/mnt/sdb8/sergei/AFSWD_debug/install/zlib-1.2.3/include'
    18  export CPPFLAGS
    19
    20  ./configure 
CC="/mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.3/binsh/gcc"
CFLAGS='-march=native -mtune=native -g -O2'
--with-binutils=/mnt/sdb8/sergei/AFSWD_debug/install/binutils-2.19.1
--prefix=/mnt/sdb8/sergei/AFSWD_debug/install/glibc-2.11.1
".

Do you see all the versions of all the dependincies ?

So, lets get back to my "Test 1" - again, here is the question:

"
The question: is it normal that 'configure' fails for some 'glibc' versions and
not the others ?
"

- I remind, everything other than 'glibc' version is the same - ensured by my
AppsFromScratch.

Anybody ?

Or, if there is a cautious person, if I send _all_ the log files, is that
cautious person willing _to_ _consider_/_indeed_ _analyze_ the problem, and not
just mark the problem as duplicate of bug #333 ?


...

Here is another test of 'glibc' developers' honesty, courage, integrity - the
same CPPFLAGS I mentioned a number of times. I have just investigated the issue
a little bit deeper.

Test 3 BEGIN.

A simple command:

"
/mnt/sdb8/sergei/AFSWD_debug/build/glibc-2.11.1/configure --help | cat -n | tail
   119    CPPFLAGS    C/C++/Objective C preprocessor flags, e.g. -I<include dir> if
   120                you have headers in a nonstandard directory <include dir>
   121    CPP         C preprocessor
   122    CXX         C++ compiler command
   123    CXXFLAGS    C++ compiler flags
   124
   125  Use these variables to override the choices made by `configure' or to help
   126  it to find libraries and programs with nonstandard names/locations.
   127
   128  Report bugs to <glibc>.
"

- does everybody see

"
   119    CPPFLAGS    C/C++/Objective C preprocessor flags, e.g. -I<include dir> if
   120                you have headers in a nonstandard directory <include dir>
"
?

Support of CPPFLAGS is a standard 'configure' feature, but, as I said, it
doesn't work.

Now, look at this:

"
cat -n /mnt/sdb8/sergei/AFSWD_debug/build/glibc-2.11.1.src/Makeconfig | grep
CPPFLAGS | head -2
   147  # We don't want CPPFLAGS to be exported to the command running configure.
   148  unexport CPPFLAGS
"

- does everyone see unexport CPPFLAGS ? Does everyone see "We don't want
CPPFLAGS to be exported to the command running configure" ?

Based on traditional 'configure' behavior and based on 'configure' built-in help
message one _should_ expect support of CPPFLAGS, but the code indicates that the
support is intentioanlly removed.

The question: will 'glibc' developers agree that their documentation does not
correspond to their code, so either the documentation, or the code, or both have
bugs ?

Just a simple YES or NO. I am still waiting.

Test 3 END.

Comment 100 Greg 2010-02-06 01:10:24 UTC
And here I thought that Linux was ready for "Prime Time." It is because of the
attitude of the engineers that Linux is not as used as Windows. In the case of
Microsoft, they don't even have a bug reporting system. If you want support, you
have to pay for it.

You won't fix the bugs that we complain about, you just fix the ones you want.

In this particular case, to make things really easy for the engineers, just
remove the global Bugzilla existence completely. Just make it accessible by the
engineers.

Comment 101 joseph@codesourcery.com 2010-02-06 01:22:37 UTC
Subject: Re:  Do not report build errors in bugzilla!

On Sat, 6 Feb 2010, sergstesh at yahoo dot com wrote:

> qemu@amdam2:/mnt/sdb8/sergei/AFSWD_debug> ls -ltrD install/
[...]
> Do you see all the versions of all the dependincies ?
[...]

You appear to have written by far the longest comment in this issue.  I 
suggest that shorter reports with exactly the relevant information and 
nothing else - exactly the path of causes leading to a failure without 
anything not contributing to that path, and without abuse of those you 
would hope would fix the reported issue - would be better received.  
Contributions of patches - again with all required explanation and nothing 
irrelevant - would be even better.  I freely admit that the glibc 
documentation is very out of date - a quick glance at the FAQ should make 
its out-of-date-ness extremely obvious - and should be brought up to date; 
patches welcome.

Comment 102 Petr Baudis 2010-02-06 13:30:00 UTC
YES, our documentation is out-of-date frequently, especially in matters such as
the build system. Also, glibc is in a sense a special case - only very few
regular users compile it themselves, it is a core system library that does not
by definition fit into a well-defined place in the FHS, and so on. Which is not
to say that it wouldn't be nice if the process was more fool-proof, but the
comparison is not completely fair.
Comment 103 Ulrich Drepper 2010-02-22 23:39:22 UTC
*** Bug 11311 has been marked as a duplicate of this bug. ***
Comment 104 Ulrich Drepper 2010-04-09 02:59:26 UTC
*** Bug 10888 has been marked as a duplicate of this bug. ***
Comment 105 Petr Baudis 2010-06-01 02:59:51 UTC
*** Bug 10423 has been marked as a duplicate of this bug. ***
Comment 106 Ulrich Drepper 2010-08-04 07:12:35 UTC
*** Bug 11875 has been marked as a duplicate of this bug. ***
Comment 107 Sergei Steshenko 2010-08-04 07:56:45 UTC
Everybody, just have a look at
http://sourceware.org/bugzilla/show_bug.cgi?id=11875 .

To make long story short - a functional dependency on 'gnu_indirect_function'
has been introduced, 'configure' reports that the feature is not supported, but
does not fail, 'make' fails, and Mr. Ulrich Drepper shows again his incompetence
refusing to admit it's a regression failure - I tried to build glibc-2.12.1
using _exactly_ the same settings as glibc-2.11.2 - the latter built just fine.
Comment 108 Sergei Steshenko 2010-08-04 08:00:53 UTC
So, is there at least one developer having personal courage to admit that

http://sourceware.org/bugzilla/show_bug.cgi?id=11875

is a case of regression failure (previous version worked, current version doesn't) ?
Comment 109 Sergei Steshenko 2010-08-04 15:33:43 UTC
Copy-pasting here http://sourceware.org/bugzilla/show_bug.cgi?id=11875#c15 :

> Of course this is a 333 dup.  Don't ever file build problem reports in BZ.  This
> is what mailing lists are for.
> 
> *** This bug has been marked as a duplicate of 333 ***

So, I've debugged the issue a little further.

The newest assembly I have (and it is supplied through the autogenerated
'configure' wrapper) does support 'gnu_indirect_function':

"
sergei@amdam2:~/junk> cat conftest.s
.type foo,%gnu_indirect_function
sergei@amdam2:~/junk>
/mnt/sdb8/sergei/AFSWD_debug/install/binutils-2.20.1/binsh/as conftest.s
sergei@amdam2:~/junk> echo $?
0
sergei@amdam2:~/junk>
".

The 'as' by default installed on my box doesn't:

"
sergei@amdam2:~/junk> cat conftest.s
.type foo,%gnu_indirect_function
sergei@amdam2:~/junk> which as
/usr/bin/as
sergei@amdam2:~/junk> as conftest.s
conftest.s: Assembler messages:
conftest.s:1: Error: unrecognized symbol type "gnu_indirect_function"
sergei@amdam2:~/junk>       
".

The 'gcc' I am using to build the whole thing was built with installed by
default 'as', so it doesn't support 'gnu_indirect_function':

"
sergei@amdam2:~/junk> cat conftest.s
.type foo,%gnu_indirect_function
sergei@amdam2:~/junk> /mnt/sdb8/sergei/AFSWD_debug/install/gcc-4.4.4/binsh/gcc
conftest.s
conftest.s: Assembler messages:
conftest.s:1: Error: unrecognized symbol type "gnu_indirect_function"
sergei@amdam2:~/junk>
".

So now the bug is even more obvious - 'configure' should have stopped after
detecting that 'gnu_indirect_function' is not supported.

So, it looks like RedHat/Mr. Ulrich Drepper QA process simply sucks - nobody
apparently bothered to check build mechanism in case of no support for
'gnu_indirect_function'.
.
Comment 110 Andreas Jaeger 2010-08-04 19:54:44 UTC
*** Bug 11875 has been marked as a duplicate of this bug. ***
Comment 111 Ulrich Drepper 2011-01-16 16:03:22 UTC
*** Bug 12403 has been marked as a duplicate of this bug. ***
Comment 112 Ulrich Drepper 2011-06-08 23:31:27 UTC
*** Bug 12858 has been marked as a duplicate of this bug. ***
Comment 113 Ulrich Drepper 2011-07-12 14:30:10 UTC
*** Bug 12985 has been marked as a duplicate of this bug. ***
Comment 114 Ulrich Drepper 2011-07-20 16:16:04 UTC
*** Bug 13008 has been marked as a duplicate of this bug. ***
Comment 115 Ulrich Drepper 2011-07-22 01:35:53 UTC
*** Bug 13015 has been marked as a duplicate of this bug. ***
Comment 116 Joseph Myers 2012-02-18 15:04:12 UTC
As I said in bug 11878:

We're planning to move the glibc FAQ to the wiki.  I'd be inclined to say we
should also close bug 333 at the same time, and officially say that build bug
reports in Bugzilla are fine if they have all the expected information - with
an explanation in the FAQ of what is relevant and of known build issues (such
as compilers defaulting to i386 rather than more recent x86; trying to build
for a ports architecture without the ports add-on; building with certain
distribution compilers that default to -fstack-protector; all of these should
of course be detected by configure, but the FAQ is the place for longer
explanations of how to fix them); the FAQ would also discuss how builds of
low-level system libraries such as glibc are intrinsically more complicated
than those of almost all other software.  But where build failures result from
old compilers, linkers etc., I think we should also be more active in
increasing the minimum versions required by configure (rather than trying to
work around deficiencies in older versions).  Roland, Carlos, Ryan - what do
you think?

See also Andrew Pinski's comment of 2006-08-04.  Build failures can have tricky system dependencies, but so can e.g. some concurrency issues reported as NPTL bugs.  If we look at reported bugs promptly then we can make sure they have all the relevant information - and if we make configure detect problems with the build environment and give errors early, we can reduce the incidence of duplicate reports for the same environmental problem.
Comment 117 Joseph Myers 2012-02-21 00:07:00 UTC
We have decided that build bugs will now be taken in Bugzilla as with other types of bugs.  Please file them in the "build" component, taking special care to include all the information requested at http://www.gnu.org/software/libc/bugs.html about the build environment and how to reproduce the problem, and expect to need to iterate with the developers on the debugging process.
Comment 118 Jackie Rosen 2014-02-16 17:46:47 UTC Comment hidden (spam)
Comment 119 Elion 2015-11-20 18:30:27 UTC Comment hidden (spam)